import { Promise } from 'q';
import { CrudAccessControl } from './access-control.authorization';
import { Response } from 'express';
import { Model, Document, DocumentQuery } from 'mongoose';
export declare class AccessControlBaseController {
    private model;
    promisedAc: Promise<CrudAccessControl>;
    constructor(model: Model<Document>, grants: any);
    create(req: any, res: Response): void;
    find(req: any, res: Response, exQueryBuilder?: (DocumentQuery) => DocumentQuery<any, any>): void;
    findById(req: any, res: Response, exQueryBuilder?: (DocumentQuery) => DocumentQuery<any, any>): void;
    restrictedQueryBuilderFactory(grant: any, user: any, exQueryBuilder?: any): () => (query: any) => any;
    update(req: any, res: Response): void;
    patch(req: any, res: Response): void;
    remove(req: any, res: Response): void;
    private setOwner(grant, user);
    private findBydId(id, user, grant);
    private entityFromBody(req);
}
